#requires face or faces within a selected group or number of groups
class Crack
	def Crack::groups
	  # get the active model
	  model = Sketchup.active_model
	  #get currently selected objects
	  selection_set = model.selection
		cracks = 0
		stepbystep = UI.messagebox "Exclude random faces from cracking?", MB_YESNOCANCEL, "Proceed"	#use to validate each face before its drawn
		if stepbystep == 2
			return nil
		end
		Sketchup.active_model.start_operation "Crack groups"
		# loop through all the selected faces, and triangulate them
		selection_set.each {|group|
			#selection_set.remove group
			if group.typename == "Group" then
				maxcracks = group.entities.count * 2
				group.entities.each {|entity|
					if cracks > maxcracks then
						return nil
					end
					entities = group.entities
					if entity.typename == "Face" then #to crack a triangle
						# get all the vertices for the current face
						vertices = entity.vertices
						# find the centroid - equals the average of all vertices, so lets add all coordinates together to divide it
						centerx = 0
						centery = 0
						centerz = 0				
						0.upto(vertices.length-1) do |vert|
							centerx = centerx + (vertices[vert].position[0]/vertices.length)
							centery = centery + (vertices[vert].position[1]/vertices.length)
							centerz = centerz + (vertices[vert].position[2]/vertices.length)
						end
						geomcen = Geom::Point3d.new(centerx,centery,centerz)
						#prepare the randomly excluded face crack
						random_exclusion = rand(vertices.length-1)
						# insert the edges
						0.upto(vertices.length-1) do |vindex|
							if vindex != random_exclusion or stepbystep == 7 then
								edge = entities.add_edges geomcen,vertices[vindex]
								cracks = cracks + 1
							end
						end
					end
				}
			end
		}
		Sketchup.active_model.commit_operation
	end #def
end #class
if( not $cracking_menu_loaded )
	$tooling_sub_menu.add_item("Polygon Cracking") { Crack.groups }
	$cracking_menu_loaded = true
end