class Qdelaunay
	def Qdelaunay::mesh
		qfile=File.dirname(__FILE__)+$dirsep+"qhull.exe"
		qfile=qfile.gsub('/',$dirsep)
		qcom=qfile + " TI tooling"+$dirsep+"points.txt"
		qmethod=" d Qbb"
		qparams=" o"
		qexport=" TO tooling"+$dirsep+"qdelaunay.txt"

		#output to file
		system(qcom + qmethod + qparams + qexport)
		
		points_file_path=File.dirname(__FILE__)+$dirsep+"qdelaunay.txt"
		points=File.new(points_file_path.to_s,"r") #opens the input file
	  table_lines = IO.readlines(points_file_path.to_s)
		dimensions = table_lines[0].to_i-1	#number of dimensions is 1 unit higher in the .txt file
		numbers = table_lines[1].split
		number_of_vertices = numbers[0].to_i
		number_of_faces = numbers[1].to_i

		Sketchup.active_model.start_operation "Build delaunay"
			if (dimensions == 3) then
				facelayer=Sketchup.active_model.layers.add("3D Delaunay")
				facelayer.visible=true
			else
				edgelayer=Sketchup.active_model.layers.add("2D Delaunay")
				edgelayer.visible=true
			end
			
			startline = 2+number_of_vertices
			0.upto(number_of_faces-1) do |i|
				facepoints = table_lines[i+startline].split
				ptf = []
				current_point = []
				removepoint = 0
				normalpos = 0
				facepoints.delete_at(0) #removes the first item specifying the number of face verticies
				0.upto(facepoints.length-1) do |j|
					if facepoints[j].to_i >= 0 and facepoints[j].to_i <= number_of_vertices then
						current_point = table_lines[facepoints[j].to_i+2].split
						x = (current_point[0].to_f.to_l)
						y = (current_point[1].to_f.to_l)
						if(dimensions == 4) then
							z = (current_point[2].to_f.to_l)
						else
							z = 0.to_f
						end
						ptf[j-removepoint] = Geom::Point3d.new(x,y,z)
					else 
						removepoint = removepoint + 1
					end
				end
				if(dimensions == 3) then
						drawfaces = Sketchup.active_model.active_entities.add_face(ptf)
						drawfaces.layer = facelayer
				else
					drawedges = Sketchup.active_model.active_entities.add_edges(ptf)
					if drawedges
						UI.messagebox drawedges
						drawedges.each{|e|
						e.layer=edgelayer
						}
					end	
				end
			end #loop
		Sketchup.active_model.commit_operation
	end #def
end #class
if( not $qdelaunay_menu_loaded )
	$tooling_sub_menu.add_item("Delaunay") { Qdelaunay.mesh }
	$qdelaunay_menu_loaded = true
end
