class Qexport
	def Qexport::points (param)
		param = 1
	  model = Sketchup.active_model
	  model.start_operation "Export points"
	  entities = model.active_entities
	  ss = model.selection

		if ss.empty? 
	    UI.messagebox("Sorry, no selection.")
	    return nil
	  end
		
		to_remove = []
		0.upto(ss.length - 1) do |look|
      to_remove.push(ss[look]) if not(ss[look].class == Sketchup::ConstructionPoint)
	  end
		to_remove.each {|e| ss.remove(e)}
	 		
	  # Fill an array of 3D_points with selection
	  points_array = []
		#create bounding box
		selectionbounds= Geom::BoundingBox.new
			
	    # read the points in the file and create the vertex array
	    for ind in (0..(ss.length - 1))
	      cpt = ss[ind]
				selectionbounds.add(cpt.bounds)	#add each vertice to form the bounding box
	      x = cpt.position[0].to_f
	      y = cpt.position[1].to_f
	      z = cpt.position[2].to_f
	      points_array[ind] = [x, y ,z]
	    end
			j = 0
			#check for the number of dimension of the selected vertices
			if (selectionbounds.corner(0)[2] == selectionbounds.corner(7)[2]) then
				dimensions = 2
			else
				dimensions = 3
			end
			#only when points are flat (coplanar with the x and y axes) it is 2
			#add bounding vertices from the bounding box corners array
			stepbystep = UI.messagebox "Do you want export the bounding box too?", MB_YESNO, "Proceed"
			if stepbystep == 6 then
				points_array.length.upto(points_array.length + 7) do |i|
					cpt = selectionbounds.corner j
					x = cpt[0].to_f
					y = cpt[1].to_f
					z = cpt[2].to_f
					points_array[i] = [x, y ,z] #comment this line to exclude bounding box corners
					j = j + 1
				end
			end
			points_array.uniq!
	  return points_array, dimensions
	end #of def

	def Qexport::write
		triangles = []
		points_table = []
		point_results = Qexport.points(0)
		points_table = point_results[0]
		dimensions = point_results[1]

		if points_table
			points_file_path=File.dirname(__FILE__)+$dirsep+"points.txt"
			points=File.new(points_file_path,"w")
			#first line contains number of dimensions and number of verticies
			points.puts dimensions.to_s + " #{points_table.length}"
			#afterwards each vertice gets exported
			0.upto(points_table.length - 1 ) do |i|
					vertice = points_table[i]
					x = (vertice[0] * 1000000000).round.to_f / 1000000000
					y = (vertice[1] * 1000000000).round.to_f / 1000000000
					if(dimensions==3) then
						z = (vertice[2] * 1000000000).round.to_f / 1000000000
						points.puts "#{x} #{y} #{z}"
					else
						points.puts "#{x} #{y}"
					end
					
			end
			points.close
		  triangles = triangulate(points_table)
		end
	end #of def

end #class
if( not $qexport_menu_loaded )
	$tooling_sub_menu.add_item("Export CPoints") { Qexport.write }
	$qexport_menu_loaded = true
end