class Recursive
	def Recursive::start
	  # get the active model
	  model = Sketchup.active_model
	  #get currently selected objects
	  selection_set = model.selection
		cracks = 0
		generations = 2
		maxcracks = selection_set.length * generations
		Sketchup.active_model.start_operation "Recursive growth"
		selection_set.each {|edge|
			if edge.typename == "Edge" then
				if cracks > maxcracks then

					return nil
				end
				point1 = Geom::Point3d.new edge.vertices[0]
				point2 = Geom::Point3d.new edge.vertices[1]
				dir_vector = point2 - point1
				direction = [dir_vector.x,dir_vector.y,dir_vector.z]

				direction.delete(0)
				orig_vector = direction
				orig_vector.sort
				least_aligned = orig_vector[0]
				least_aligned = dir_vector.to_a.index(least_aligned)
				cross_vector = []
				if(direction.length > 1) then #the edge is colinear with an axis
					0.upto(2) do |i|
						if(i==least_aligned) then
							cross_vector[i] = 1
						else
							cross_vector[i] = 0
						end
					end
					cardinal_vector = Geom::Vector3d.new cross_vector
					normal_vector = dir_vector.cross cardinal_vector			
				else
					0.upto(2) do |i|
						if(i==least_aligned) then
							cross_vector[i] = 0
						else
							cross_vector[i] = 1
						end
					end
					normal_vector = Geom::Vector3d.new cross_vector
				end

				# find the centroid - equals the average of all vertices, so lets add all coordinates together to divide it
				centerx = 0
				centery = 0
				centerz = 0				
				0.upto(1) do |vert|
					centerx = centerx + (edge.vertices[vert].position[0]/2)
					centery = centery + (edge.vertices[vert].position[1]/2)
					centerz = centerz + (edge.vertices[vert].position[2]/2)
				end
				geomcen = Geom::Point3d.new(centerx,centery,centerz)
				normal_vector.length = (dir_vector.length/3)*rand
				offset = geomcen + normal_vector
				# insert the edges
				0.upto(1) do |vindex|
					newedge = Sketchup.active_model.active_entities.add_edges offset,edge.vertices[vindex]
					#add new edge to the selection set
					selection_set.add newedge
					cracks = cracks + 1
				end
				
				#remove the original edge from the selection set
				selection_set.remove edge
				
				#delete original edge
				edge.erase!
			end
		}
		Sketchup.active_model.commit_operation
	end #def
end #class
if( not $recursived_menu_loaded )
	$tooling_sub_menu.add_item("Recursive dent") { Recursive.start }
	$recursived_menu_loaded = true
end