class Qvoronoi
	def Qvoronoi::mesh
		qfile=File.dirname(__FILE__)+$dirsep+"qhull.exe"
		qfile=qfile.gsub('/',$dirsep)
		qcom=qfile + " TI tooling"+$dirsep+"points.txt"
		qmethod=" v Qbb Qj"
		qparams=" o Fv"
		qexport=" TO tooling"+$dirsep+"qvoronoi.txt"

		#output to file
		system(qcom + qmethod + qparams + qexport)
		
		points_file_path=File.dirname(__FILE__)+$dirsep+"qvoronoi.txt"
		points=File.new(points_file_path.to_s,"r") #opens the input file
	  table_lines = IO.readlines(points_file_path.to_s)
		dimensions = table_lines[0].to_i
		numbers = table_lines[1].split
		
		vertices_startline = 2
		number_of_vertices = numbers[0].to_i

		regions_startline = vertices_startline+number_of_vertices
		number_of_regions = numbers[1].to_i
		
		faces_startline = regions_startline + number_of_regions
		number_of_faces = table_lines[faces_startline].to_i

		group_ridges = 0
		
		Sketchup.active_model.start_operation "Build Voronoi"
			facelayer=Sketchup.active_model.layers.add("Voronoi")
			facelayer.visible=true
				
			startline = faces_startline
			number_ents = number_of_faces
			0.upto(number_ents-1) do |i|
				facepoints = table_lines[i+startline].split
				ptf = []
				current_point = []
				removepoint = 0

				facegroup = Sketchup.active_model.active_entities.add_group
				facegroup.name = "voronoi " + i.to_s
				
				indice_pair = []
				
				facepoints.delete_at(0) #removes the first item specifying the number of face verticies
				indice_pair[0] = facepoints.delete_at(0)	#reads and then removes information about the FIRST ridge neighbour
				indice_pair[1] = facepoints.delete_at(0)	#reads and then removes information about the SECOND ridge neighbour

				if(facepoints[0].to_i==0)then #first point is an infinite so lets reverse the current face vertices
					facepoints = facepoints.reverse
				end

				0.upto(facepoints.length-1) do |j|
					if facepoints[j].to_i <= number_of_vertices then
						if facepoints[j].to_i > 0 then
							current_point = table_lines[facepoints[j].to_i+2].split
							x = (current_point[0].to_f.to_l)
							y = (current_point[1].to_f.to_l)
							if(dimensions == 3) then
								z = (current_point[2].to_f.to_l)
							else
								z = 0.to_f
							end
							ptf[j-removepoint] = Geom::Point3d.new(x,y,z)
						elsif facepoints[j].to_i == 0 then	#try to look for the infinite coordinate
							removepoint = removepoint + 1
						else
							#remove invalid coordinate
							removepoint = removepoint + 1
						end
					else 
						removepoint = removepoint + 1
					end
				end
				0.upto(ptf.length-1) do |point|
					firstlast_edge = []
					firstlast_edge[0] = ptf[point]
					if(point == (ptf.length-1)) then
						firstlast_edge[1] = ptf[0]
					else
						firstlast_edge[1] = ptf[point+1]
					end
					if(group_ridges == 1) then
						drawedges = facegroup.entities.add_edges(firstlast_edge)
						if drawedges
							drawedges.each{|e| e.layer=facelayer}
						end
					else
						drawedges = Sketchup.active_model.active_entities.add_edges(firstlast_edge)
							if drawedges
								drawedges.each{|e| e.layer=facelayer}
							end
						if(ptf.length > 2) then
							ridgeface = Sketchup.active_model.active_entities.add_face(ptf)
							ridgeface.layer=facelayer
						end
					end
				end
			end
		Sketchup.active_model.commit_operation
	end #def
end #class
if( not $qvoronoi_menu_loaded )
	$tooling_sub_menu.add_item("Voronoi") { Qvoronoi.mesh }
	$qvoronoi_menu_loaded = true
end